var m_button = false;
var m_inited = false;
var m_prefs = false;
var m_pb_prefs = false;

function proxybutton_switchProxy() {

    var nCurProxyType = m_prefs.getIntPref("network.proxy.type");
    if (nCurProxyType == 0) {
        proxybutton_setManual();
    } else {
        proxybutton_setDirect();
    }
}

function proxybutton_init() {
    if (!m_prefs) {
    	proxybutton_initPrefObjects();
    }
    proxybutton_checkPreferencesExist();
    if (!m_inited) {
       if (document.getElementById("proxybutton-button")) {
            m_button = document.getElementById("proxybutton-button");
       } else if (document.getElementById("proxybutton-button-tb")) {
            m_button = document.getElementById("proxybutton-button-tb");
       } else {
            m_button = document.getElementById("proxybutton-button-tb-msg");
       }

       m_inited = true;

       var rObserver = {
          observe : function(subject, topic, data) { proxybutton_setButtonFromPreference(); }
       };
       var rPrefs  = Components.classes["@mozilla.org/preferences-service;1"].createInstance(Components.interfaces.nsIPrefBranchInternal);
       rPrefs.addObserver("network.proxy", rObserver, false);
    }
    proxybutton_setButtonFromPreference();
}

function proxybutton_setButtonFromPreference() {
    var nCurProxyType = m_prefs.getIntPref("network.proxy.type");
    if (nCurProxyType == 0) {
        proxybutton_setDirect();
    } else {
        proxybutton_setManual();
    }

}

function proxybutton_setDirect() {
    m_prefs.setIntPref("network.proxy.type", 0);
    proxybutton_changeImage(0);
}

function proxybutton_changeImage(nToType) {
    var sPrefix;

    if (nToType==0) {
        m_button.setAttribute('pbstatus', 'off');
        m_button.setAttribute('tooltiptext', 'Turn proxy on');
    } else {
        m_button.setAttribute('pbstatus', 'on');
        m_button.setAttribute('tooltiptext', 'Turn proxy off');
    }
}

function proxybutton_setManual() {
    m_prefs.setIntPref("network.proxy.type", m_pb_prefs.getIntPref('proxytype'));
    proxybutton_changeImage(1);
}

function proxybutton_initPrefObjects() {
    m_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

    m_pb_prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    m_pb_prefs = m_pb_prefs.getBranch("extensions.proxybutton.");
}

function proxybutton_initPreferences(pb_pref_radio) {
    if (!m_prefs) {
        proxybutton_initPrefObjects();
    }
    proxybutton_checkPreferencesExist();
    
    pb_pref_radio.selectedIndex = m_pb_prefs.getIntPref('proxytype')-1;
}

function proxybutton_savePreferences(pb_pref_radio) {
    m_pb_prefs.setIntPref('proxytype', pb_pref_radio.selectedItem.value);
}

function proxybutton_checkPreferencesExist() {
    try {
        m_pb_prefs.getIntPref('proxytype');
    } catch (rErr) {
        // Got exception - it seems that there's no such preference. Smash it in.
        m_pb_prefs.setIntPref('proxytype', 1);
    }
}